"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringify = void 0;
var significantFields_1 = require("./significantFields");
var isObject = function (_) { return new Object(_) === _; };
var isDate = function (_) { return _ instanceof Date; };
var isArray = function (_) { return Array.isArray(_); };
var isPrimitive = function (_) { return !isObject(_); };
/**
 * @access private
 */
function stringify(v) {
    switch (true) {
        case isArray(v):
            return "".concat(v.constructor.name, "(").concat(v.map(function (i) { return stringify(i); }).join(', '), ")");
        case isDate(v):
            return v.toISOString();
        case isObject(v):
            var fields = (0, significantFields_1.significantFieldsOf)(v)
                .map(function (field) { return ({ field: field, value: stringify(v[field]) }); })
                .reduce(function (acc, current) {
                return acc.concat("".concat(current.field, "=").concat(current.value));
            }, []);
            return "".concat(v.constructor.name, "(").concat(fields.join(', '), ")");
        case isPrimitive(v):
        default:
            return "".concat(v);
    }
}
exports.stringify = stringify;
//# sourceMappingURL=stringify.js.map